# Made by Sora_
# Thanks to the Genshin Impact Modding Community for their help and support
# Thanks to LeoTorreZ and SilentNightSound, this script is adapted from their script
# Thanks for BladeMouX and Plutoisy, for allowing me to find these hashes in advance
# Special thanks for !someone name has 63B long? help me complete this script

# Fixes Huohuo, Bailu, Luocha, Fuxuan, Gepard, Silver Wolf, Kafka, Welt, Ruanmei, Bronya, Argenti, Jingyuan, Himeko, Dr Ratio, Yanqing, Topaz, Seele, Lunae, Jingliu, Blade, Clara, Lynx, Natasha, March7th, Guinaifen, Luka, Pela, Hanya, Yukong, Tingyun, Asta, Qingque, Serval, Herta, Sushang, Danheng, Xueyi, Hook and Arlan
# Note: This fix DOES NOT contain the fixes before 1.6 - for older mods, find 1.6 version of them

# ##########################################################################################################################
#     ................                .... ..   ..               ............. ............                              
#     ................                ... ...                    .........................                               
#   ..............            ....                 ..            ........,]`.]............                               
# ................            ......                             ...,/\]/O],*,[\[]........                               
# ............                                           ........,/\@O@/,/\]]],`=`*,=\`...........                       
# .......... .        ..                                 ....../@\@@/`/*`,/\/\[,*,,**=OO]]]........                      
# ............                                        .. ..../O\O@[,,,///`********,*`,]\]*/\`.....                       
# ...........  ...                                    .. .../O@@^*,/\/`*/\***********,**/*/\/.....                       
# ............. .... .                     .  ............][\ooo\O\@^]/ooo`****,*****`*`^`/O@O..... ..                .. 
# ............. .... .                   ............,O\OOO\oo]OOo@`@OO//`***,\\,,``/^,\^,***[\....                      
# ............                            .............,//*,*]/oO^\@ooooo/^*]\]/`\*//**=**`[^*/^...                      
# ............                            ...=]]]]]/[**`*,,*/\o@`O@O/OO\=O/[O\``[/^/``*O]`**,^\\....                     
# ............ ...                       ......,OooooO/@@/o\[//=@o@o//,OOO/\//*/\OO\]`=\^*O]/@@\^..       .. .           
# ............    ..                      ........[@O\oooo\O@/@OOO\///O/\\@^]@\OOO\\\oOO^\@o]OO\^..       .. .           
# .......... .....    ..      .  .       ............/oo/\/,\@O@O@\OO\^]]@@/\,\//`=OO\O@^@O/=\\OO`....        ..         
# ..... ....... ..... .       ....        .........,//O[[]OOOOOO/O/@@@@@@\/]o\OO`=O@\=OO/O/,=/^@@@....        ..         
# ................            .....  .............=\`*`/\OOooO/@/@,O@@@@O^,@\OO*=O@\*oOOOO^=^/@/@,\... ..         .......
# ................            ....        ......,//*,/OOOoO\=/OOo^\\.\O/.../O//\/@\O\@@\OO*@\O=\@..=.....         ....   
# ................                    ........,/,/,//OO\/*,*@oOO\^O@......*O/`.**\@@@^@@@^/\O^**=^........               
# ...,]/\]].....                      .....]\\*/O\@oo\/,`*/@Oo/@o^=^.....,.......@O@`/@@^@/oO`\OO^... .                  
# .,/`@O[*............................,]/^**/@O/OOOO``*,\o@O/\OO/^=\..........[...,.*@O@@OO@,*/=/..                      
# O,[,`\]/[\/OOO\/^[*,\/**,]]]]]]O\Oo\,*,/OO@@oOO`**,*,oO\/*@@@@/o,@\`..............@O@Oo@@`*/./...                      
# \,/[,*`,\//@//oo\O]*,\`..\/**`,Oo/[OOo@O@\O/\//o\,`\//[*//@@@O@o`@^@`.[,......../@\@OO@@*=`......                      
# O/@//\`*/**[\/\OO\@\\`\[\..\][\/@OO\OO^OO/]o/o/o\[/\*,/O/\@@@\O@O@,/@\.`..,]/@@OOO@@o@@/`.......                       
# \/...,,[[\`*,*\\\/O[@.,//*./OOOO@@@OO@Ooo\o\@/\[,*\,OO@oo@@@@@O@@@=@@@@@@@@OO@=@@@OOO\O^.. ... .                       
# .......*``],,``/\O]*/..\\^=\/oOo///\oOOOOO\]`*/`/]OO/oOO\O@@@@@@@@@@@@@@@@@O@@@@O\O@OO=^...     .. .                   
# .../\\\\\=\/O\/[^\`=/...`.@\],/O`**\]`oooooo^O@\oo\@O@OOOOOOOO@@@@/@@@@@@@@@@\OO@@@/\/=.......  ..                     
# ./OooooOO/^/^***/\,/@`....@/`,,*`*`*/]]O/@//ooOOO/@@@@O\OOOOOOOOOOOO@O]\@@@@O@@@@@@OO@OO^......         ....           
# OooO/@\o\/*`******/@O^....@.*`*`***]/@@OOOOOOO/O@@OO\@@@@OOOOOO@@OO@OOOO@@@@@OOO@@@@@O@@O^.......               ....   
# OOO\Oo\/**`**,**\]`@,=^**//\\/\\\`O\oO@/`/@O\@@OOOOOOOO@@@@OOO/@@@@@@@OOO@@@@OOOOO@@@@@@@O\..  .                . ..   
# OOOOO@[,,*`]/Oooooo\Ooo\oo/O`/\@*[,[O@/O\OOO@@OOOOOO@OOOO@@@@OOOOO@@@@@O@@@/@\@@[OOOOO@@@@OO`...         .......       
# OOOo/*`,,@oooo\oooo\//@\oo/O\//,\@OooOOOoo@O@OOOOO@@O@@@@@@@O@OOOOOO@@\\@@OO\OO@@`\/OOO\@@OO@...          . ....       
# OOo@*``/\/[.......,.==@@OO/OO\/\^OO/@\OoO\@@@@@@@@@@@@@@@@@\@@@@@OOO@@@/@@OOOOO@@@@@OOOOOO@OO^...       ....           
# OOOO,,/............^,@@O\@^@O/\//OO@@@@@@@@@@@@@@@@OOO/OOOOOO@O\@OOO@@@@@O]]\]]/O@\OOOOOOOOO@O...         ..           
# =OO/.................@@OO@@@=]oo^OOO@@@@@OOOOOO/OO@O@@@@\OOOOOO@@@@/OOOOOO@@@@@@@@@@@OO@@@@@@@^.                       
# ............,\O`.....,@O@@@OO@/\/OOOOO@@@OOOOOOOOOOOO@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@^.                       
# ............/@^........\/OOOOOO@@O/OOO@@OOOOOOOOOOOOOOOOOO\@O@@@@@@@@@@@@@@@@@@@@@@@@OOOOOO@@@^.                       
# .. ... .....^*,].........\@O/@@@@@@@@@@@@@@@@@@OOOo/O@@@@@@O/o@@@@@@@@@@@@@@@OO@@@@@@@OOOOOOO@^.              ..       
# ............\,***[].......=@@@@@@@@@@@@@@@@@@@@@@@@@@@@@OOOOOoO\@@@@@@@@OO@O@OOOOOOO@@OOOOO@@@^.  ..        ......     
# ... .........\,***,*[`......@oO@@@@@@@@@@@@@@@@@@@@@@\/OOoO/O/`*\@@@@@@@OOOOO@OOOOOOO\\OOOOOO@^..   ...       ..   .   
# ....... .......\\,*``*,[]...,@OO@@@@@@@@@@@@@@@@@@[ooooo@/^*]/O\/\@@@@@OOOO@@@OOOOOOOOOO@OOOOO\..               ....   
# .................,@@]*^,,*``**,\\@@@@@@@@@@@@@/@\oOO[]]/@\oooooooo\@@@@O@OOO@@O@@@OO\OOO@@OOOO@..               ...... 
# ....    ............[@//]]`****]\]/@@@@@@@@@O@OOOooooooooooooOooO@\\/@@@@@@@OO/@@@@@@@@@OOOOOOO\....                   
# ....  .... .... .......,\Oo//[]*^ooooooo\/@@ooOoooooOoooooOoO/`.//ooO\@@@@@@@/O@OO/@@@@@@@/OOOOO^...                   
# .. ...  ....    ..   ......[\[`/=/oooooOooooooooOOOoo/OO[`...,/Ooo\\/./@@@@@@@@@OOOO\\@@@@@@@O@@@.....                 
# ......  ....           ........[\O/[[[[[OO[[[[[\O/[`.......,O/\ooO`..=OO@@@@@@@@@OOOOOOOO@\@OO@@@@.... .               
# ....    ....           .........,/\\......................///O/`......=@@@@@@@@@@OOOOOOOOOO@OO\@@@^.....               
# ....       .            .........*=....................,[///`.........=@@@@@@@@@@OOOOOOOOOOO@O@@@@@.....               
# ...... .                  ..   ...\\................,/][`.......... ..@@@@@@@@@@@@OOOOO@@@O\@@@@@@@@....               
# ........                        ....\`.........]/OO[`.......  .......=@@@@@@@@@@@@@@@O@@@@@@@@@@@@@@^...               
# . .... .... ....              ...........[`.............      .......@@@@@@@/OOO@@@@@@@@@@@@@@/@@@O@@^..               
#   ......... ...             .   ..... ..................        ...,/@@@@@@@OOOOO/@@@@@@@OOO@@@@@OOOO@`.               
#   ........  ....                    .    ......   ................/@@@@@@@@@@OOO@OOO@@@@@OOOOO@@@OOOOO@.........       
# .   .....   ....                        .. ..  .         .. ..../@@@@@@@@@@@@@@O@@@@@@@@@@@@/O/@@OOOOOOO/`.... ..      
#    ...    ..           .                                ....../OOO@@@@@@@@@@@@@O@@@@@@@@@@@@@@@=@@OOOO\/O/\.....       
#    .... .           ....                               ...../@OOOOOO@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@OOOO\//O\\.....      
# ........        ...... .                .           ....../@OOOOOOOO@@@@@@@@@@@@@@@@@@OoO@@@@@@@OOOOOOO/o`@]O....      
# ........        .....                   ...         .....,@OOOOOO@@@@@O@=]/[[[@@@@@@@@@OOOOOOO@@OOOOOOOOo/o///`...     
# ..  ...   ..                                    .....,/@@@@@OOO@@@@@@@@\oooooooooooo/o]\\\]]/@@@@OOOOOOO/]@[O`......   
# ##########################################################################################################################

import os
import struct
import argparse
import shutil

old_vs_new = {
    # Huohuo
    "6a5bb5e7":"d457c4dd",
    "47dbd6aa":"2a306f9c",
    "d9ac0987":"67a078bd",
    "f05d31fb":"e9aecd0b",
    # Bailu
    "7053ca2b":"e2fb7ce0",
    "e5417fe2":"d7a8228a",
    "dbf90364":"680253f0",
    # Luocha
    "0631a69b":"aabdd8f5",
    "a67c4fed":"80da6fb8",
    "b5c61afb":"194a6495",
    "6c659c20":"149a218b",
    # Fuxuan
    "71906b4e":"45b0663d",
    "7d77bdb5":"c230f24a",
    # Gepard
    "d62bbd0f":"04094d7e",
    "30aa99d6":"1e4f876c",
    # Silver Wolf
    "f162c8dd":"d845b2c8",
    "2e053525":"ab13f8b8",
    "429574bd":"6bb20ea8",
    "729de5d2":"e8f10ab3",
    # Kafka
    "51abd7c9":"deb266a8",
    "17cb3b3e":"cd2222f8",
    "190e483a":"05ded7f7",
    "e25c6ba9":"6d45dac8",
    "8d847042":"fa23099d",
    # Welt
    "fef626ce":"31c9604b",
    "723e0365":"0ab3a636",
    "1dea5b29":"d15987b1",
    # Ruanmei
    "6f3b9090":"803d3eda",
    # Bronya
    "3dddc093":"08f2d6dd",
    "39d9a850":"0d67a9c3",
    "1d057d1a":"29d03f40",
    "8123eaff":"4265a087",
    "d6153000":"2ec44855",
    "7f5e24df":"4e327afb",
    "70fd4690":"2d03d71b",
    # Argenti
    "099cb678":"18af7e1c",
    "9dc7d1aa":"9dc7d1aa",
    "9de080b0":"7d57f432",
    # Jingyuan
    "f45ac261":"3423e10d",
    "ee205a7b":"1240ff30",
    # Himeko
    "5d98de11":"3cfb3645",
    "77cb214c":"b9e9ae3b",
    "e4640c8c":"e79e4018",
    # Dr Ratio
    "6fdb2c55":"6600a26e",
    "32ccb687":"e6b81399",
    "dc2c9035":"d5f71e0e",
    # Yanqing
    "664b8139":"9801327a",
    "c20cd648":"d03803e6",
    # Topaz
    "24212bf6":"436288c9",
    "ae42518c":"b52297bf",
    # Seele
    "41943cc6":"fe54239f",
    "eb699635":"6a522a54",
    # Lunae
    "0ffb8233":"0f8da6ba",
    "1a7ee87c":"7cb75a5e",
    # Jingliu
    "81c023e7":"ba517fa0",
    "5564183c":"e8d31b6a",
    # Blade
    "b931dfc7":"f7896b3e",
    "60d6a2c4":"0eb1e389",
    # Clara
    "696fa077":"3f6bd5ee",
    "5dfa8761":"a444344c",
    "da981c17":"8c9c698e",
    "f92afebc":"4a58be98",
    # Lynx
    "8e595209":"52a44eba",
    "ba91c796":"ba91c796",
    "e8c4b27f":"71647b48",
    # Natasha
    "fc66ad46":"4958a3f3",
    "9ac894b4":"b9b8b2a1",
    "005670d8":"68dd15e8",
    # March7th
    "fcef8885":"ecf4648c",
    "97ad7623":"5212ce68",
    # Guinaifen
    "6de824a0":"d08d6ebb",
    "4b1cdcfc":"506edd10",
    "6e216a03":"2eeff76f",
    "de1f98c0":"637ad2db",
    "75d5ec54":"79900144",
    # Luka
    "f7d86ef0":"3e55d897",
    "098a46fc":"11dd3da1",
    "5332e0c4":"e0c9f7ec",
    # Pela
    "6148b897":"77a2f3bf",
    "f4eb23b2":"98dbd548",
    # Hanya
    "a73510da":"69a81bdb",
    "42de1256":"b1c2c937",
    "a2312c3d":"4fb6b5f3",
    "2ef62d4b":"e58be0fd",
    # Yukong
    "a1f7c44d":"unknown",
    "1d185915":"e5e376b8",
    "1df9540b":"28bbd4ae",
    # Tingyun
    "9bf82eaa":"f83ec867",
    "351d8570":"da59600b",
    # Asta
    "46c9c299":"337e94ce",
    "099dd85b":"8fb66ce1",
    "ps-t1 = ResourceastaCDiffuse":"",
    "ps-t2 = ResourceastaCt3":"ps-t1 = ResourceastaCt3",
    # Qingque
    "3a305670":"cc2db614",
    "daafea36":"0a82ceb7",
    # Serval
    "c71fc0d0":"1bdfe263",
    "35e3d214":"86d77809",
    "44885792":"f092876d",
    # Herta
    "2074e2ef":"73749b98",
    "c12363b4":"91c0cb8e",
    "93835e8f":"c08327f8",
    "5186a9b8":"9553ff35",
    # Sushang
    "59a0b558":"23dc010c",
    "d765c517":"4b22391b",
    # Danheng
    "ab30fd81":"8bdfb25d",
    "be813760":"457b4223",
    # Xueyi
    "77b78d33":"8936451b",
    "2c096545":"03ff3d10",
    "9f040cd3":"af2983dd",
    # Hook
    "0361b6bf":"9d68704b",
    "f1788f95":"59ccb47b",
    "26276c57":"0c614d18",
    # Arlan
    "2b98f3d1":"40436908",
    "cb3a3965":"31ebfc6e",
    # Cocolia
    "acf32f49":"2d9ce0b3",
    "3bf00320":"3bf00320",
    "f65f93a1":"b0bf78bf",
}

def dynamic_replacement(match):
    # Huohuo
    if "e9aecd0b" in match:
        return "\n[TextureOverride20fixA]\nhash = e9aecd0b\nmatch_first_index = 0\nib = null"
    # Bailu
    elif "680253f0" in match:
        return "\n[TextureOverride20fixA]\nhash = 680253f0\nmatch_first_index = 0\nib = null\n\n[TextureOverride20fixB]\nhash = 680253f0\nmatch_first_index = 33984\nib = null"
    # Luocha
    elif "149a218b" in match:
        return "\n[TextureOverride20fixA]\nhash = 149a218b\nmatch_first_index = 0\nib = null\n\n[TextureOverride20fixB]\nhash = 149a218b\nmatch_first_index = 4503\nib = null"
    # Fuxuan
    elif "c230f24a" in match:
        return "\n[TextureOverride20fixA]\nhash = c230f24a\nmatch_first_index = 0\nib = null\n\n[TextureOverride20fixB]\nhash = c230f24a\nmatch_first_index = 39018\nib = null"
    # Gepard
    elif "1e4f876c" in match:
        return "\n[TextureOverride20fixA]\nhash = 1e4f876c\nmatch_first_index = 0\nib = null\n\n[TextureOverride20fixB]\nhash = 1e4f876c\nmatch_first_index = 27621\nib = null"
    # Silver Wolf
    elif "e8f10ab3" in match:
        return "\n[TextureOverride20fixA]\nhash = e8f10ab3\nmatch_first_index = 0\nib = null\n\n[TextureOverride20fixB]\nhash = e8f10ab3\nmatch_first_index = 63663\nib = null"
    # Kafka
    elif "fa23099d" in match:
        return "\n[TextureOverride20fixA]\nhash = fa23099d\nmatch_first_index = 0\nib = null\n\n[TextureOverride20fixB]\nhash = fa23099d\nmatch_first_index = 35439\nib = null"
    # Welt
    elif "d15987b1" in match:
        return "\n[TextureOverride20fixA]\nhash = d15987b1\nmatch_first_index = 0\nib = null"
    # Bronya
    elif "29d03f40" in match:
        return "\n[TextureOverride20fixA]\nhash = 29d03f40\nmatch_first_index = 34431\nib = null\n\n[TextureOverride20fixB]\nhash = 29d03f40\nmatch_first_index = 36345\nib = null"
    # Argenti
    elif "7d57f432" in match:
        return "\n[TextureOverride20fixA]\nhash = 7d57f432\nmatch_first_index = 0\nib = null\n\n[TextureOverride20fixB]\nhash = 7d57f432\nmatch_first_index = 58749\nib = null"
    # Jingyuan
    elif "1240ff30" in match:
        return "\n[TextureOverride20fixA]\nhash = 1240ff30\nmatch_first_index = 11505\nib = null\n\n[TextureOverride20fixB]\nhash = 1240ff30\nmatch_first_index = 17772\nib = null"
    # Himeko
    elif "e79e4018" in match:
        return "\n[TextureOverride20fixA]\nhash = e79e4018\nmatch_first_index = 0\nib = null\n\n[TextureOverride20fixB]\nhash = e79e4018\nmatch_first_index = 47634\nib = null"
    # Dr Ratio
    elif "d5f71e0e" in match:
        return "\n[TextureOverride20fixA]\nhash = d5f71e0e\nmatch_first_index = 0\nib = null"
    # Yanqing
    elif "d03803e6" in match:
        return "\n[TextureOverride20fixA]\nhash = d03803e6\nmatch_first_index = 0\nib = null"
    # Topaz
    elif "b52297bf" in match:
        return "\n[TextureOverride20fixA]\nhash = b52297bf\nmatch_first_index = 0\nib = null\n\n[TextureOverride20fixB]\nhash = b52297bf\nmatch_first_index = 18327\nib = null"
    # Seele
    elif "6a522a54" in match:
        return "\n[TextureOverride20fixA]\nhash = 6a522a54\nmatch_first_index = 0\nib = null\n\n[TextureOverride20fixB]\nhash = 6a522a54\nmatch_first_index = 19968\nib = null"
    # Lunae
    elif "7cb75a5e" in match:
        return "\n[TextureOverride20fixA]\nhash = 7cb75a5e\nmatch_first_index = 0\nib = null"
    # Jingliu
    elif "e8d31b6a" in match:
        return "\n[TextureOverride20fixA]\nhash = e8d31b6a\nmatch_first_index = 0\nib = null"
    # Blade
    elif "0eb1e389" in match:
        return "\n[TextureOverride20fixA]\nhash = 0eb1e389\nmatch_first_index = 0\nib = null"
    # Clara
    elif "4a58be98" in match:
        return "\n[TextureOverride20fixA]\nhash = 4a58be98\nmatch_first_index = 0\nib = null\n\n[TextureOverride20fixB]\nhash = 4a58be98\nmatch_first_index = 50910\nib = null"
    # Lynx
    elif "71647b48" in match:
        return "\n[TextureOverride20fixA]\nhash = 71647b48\nmatch_first_index = 0\nib = null"
    # Natasha
    elif "68dd15e8" in match:
        return "\n[TextureOverride20fixA]\nhash = 68dd15e8\nmatch_first_index = 0\nib = null\n\n[TextureOverride20fixB]\nhash = 68dd15e8\nmatch_first_index = 3024\nib = null"
    # March7th
    elif "5212ce68" in match:
        return "\n[TextureOverride20fixA]\nhash = 5212ce68\nmatch_first_index = 0\nib = null\n\n[TextureOverride20fixB]\nhash = 5212ce68\nmatch_first_index = 30828\nib = null"
    # Guinaifen
    elif "79900144" in match:
        return "\n[TextureOverride20fixA]\nhash = 79900144\nmatch_first_index = 8907\nib = null\n\n[TextureOverride20fixB]\nhash = 79900144\nmatch_first_index = 34146\nib = null"
    # Luka
    elif "e0c9f7ec" in match:
        return "\n[TextureOverride20fixA]\nhash = e0c9f7ec\nmatch_first_index = 25371\nib = null\n\n[TextureOverride20fixB]\nhash = e0c9f7ec\nmatch_first_index = 52830\nib = null"
    # Pela
    elif "98dbd548" in match:
        return "\n[TextureOverride20fixA]\nhash = 98dbd548\nmatch_first_index = 0\nib = null"
    # Hanya
    elif "b1c2c937" in match:
        return "\n[TextureOverride20fixA]\nhash = b1c2c937\nmatch_first_index = 0\nib = null\n\n[TextureOverride20fixB]\nhash = b1c2c937\nmatch_first_index = 28818\nib = null"
    # Yukong
    elif "28bbd4ae" in match:
        return "\n[TextureOverride20fixA]\nhash = 28bbd4ae\nmatch_first_index = 0\nib = null"
    # Tingyun
    elif "da59600b" in match:
        return "\n[TextureOverride20fixA]\nhash = da59600b\nmatch_first_index = 0\nib = null\n\n[TextureOverride20fixB]\nhash = da59600b\nmatch_first_index = 53229\nib = null"
    # Asta
    elif "8fb66ce1" in match:
        return "\n[TextureOverride20fixA]\nhash = 8fb66ce1\nmatch_first_index = 12510\nib = null\n\n[TextureOverride20fixB]\nhash = 8fb66ce1\nmatch_first_index = 47880\nib = null"
    # Qingque
    elif "0a82ceb7" in match:
        return "\n[TextureOverride20fixA]\nhash = 0a82ceb7\nmatch_first_index = 0\nib = null\n\n[TextureOverride20fixB]\nhash = 0a82ceb7\nmatch_first_index = 45615\nib = null"
    # Serval
    elif "f092876d" in match:
        return "\n[TextureOverride20fixA]\nhash = f092876d\nmatch_first_index = 13731\nib = null\n\n[TextureOverride20fixB]\nhash = f092876d\nmatch_first_index = 30048\nib = null"
    # Herta
    elif "9553ff35" in match:
        return "\n[TextureOverride20fixA]\nhash = 9553ff35\nmatch_first_index = 8814\nib = null"
    # Sushang
    elif "4b22391b" in match:
        return "\n[TextureOverride20fixA]\nhash = 4b22391b\nmatch_first_index = 3531\nib = null\n\n[TextureOverride20fixB]\nhash = 4b22391b\nmatch_first_index = 30774\nib = null"
    # Danheng
    elif "457b4223" in match:
        return "\n[TextureOverride20fixA]\nhash = 457b4223\nmatch_first_index = 0\nib = null"
    # Xueyi
    elif "af2983dd" in match:
        return "\n[TextureOverride20fixA]\nhash = af2983dd\nmatch_first_index = 0\nib = null\n\n[TextureOverride20fixB]\nhash = af2983dd\nmatch_first_index = 39129\nib = null"
    # Hook
    elif "0c614d18" in match:
        return "\n[TextureOverride20fixA]\nhash = 0c614d18\nmatch_first_index = 0\nib = null"
    # Arlan
    elif "31ebfc6e" in match:
        return "\n[TextureOverride20fixA]\nhash = 31ebfc6e\nmatch_first_index = 0\nib = null"
    # Cocolia
    elif "b0bf78bf" in match:
        return "\n[TextureOverride20fixA]\nhash = b0bf78bf\nmatch_first_index = 8841\nib = null\n\n[TextureOverride20fixB]\nhash = b0bf78bf\nmatch_first_index = 25107\nib = null"
    else:
        return ""

replacement_mapping = {
    # Huohuo
    "e9aecd0b": {
        "hash = e9aecd0b\nmatch_first_index = 0":"hash = e9aecd0b\nmatch_first_index = 45165",
        "": dynamic_replacement,
    },
    # Bailu
    "680253f0": {
        "hash = 680253f0\nmatch_first_index = 0":"hash = 680253f0\nmatch_first_index = 56496",
        "match_first_index = 36429":"match_first_index = 62601",
        "": dynamic_replacement,
    },
    # Luocha
    "149a218b": {
        "hash = 149a218b\nmatch_first_index = 34437":"hash = 149a218b\nmatch_first_index = 45126",
        "match_first_index = 0":"match_first_index = 34437",
        "": dynamic_replacement,
    },
    # Fuxuan
    "c230f24a": {
        "hash = c230f24a\nmatch_first_index = 0":"hash = c230f24a\nmatch_first_index = 57636",
        "match_first_index = 46797":"match_first_index = 65415",
        "": dynamic_replacement,
    },
    # Gepard
    "1e4f876c": {
        "hash = 1e4f876c\nmatch_first_index = 0":"hash = 1e4f876c\nmatch_first_index = 57774",
        "match_first_index = 31266":"match_first_index = 55773",
        "": dynamic_replacement,
    },
    # Silver Wolf
    "e8f10ab3": {
        "hash = e8f10ab3\nmatch_first_index = 0":"hash = e8f10ab3\nmatch_first_index = 63663",
        "match_first_index = 64392":"match_first_index = 63549",
        "": dynamic_replacement,
    },
    # Kafka
    "fa23099d": {
        "hash = fa23099d\nmatch_first_index = 0":"hash = fa23099d\nmatch_first_index = 8787",
        "": dynamic_replacement,
    },
    # Welt
    "d15987b1": {
        "hash = d15987b1\nmatch_first_index = 30588":"hash = d15987b1\nmatch_first_index = 46620",
        "match_first_index = 0":"match_first_index = 30588",
        "": dynamic_replacement,
    },
    # Bronya
    "29d03f40": {
        "hash = 29d03f40\nmatch_first_index = 36345":"hash = 29d03f40\nmatch_first_index = 60423",
        "": dynamic_replacement,
    },
    # Argenti
    "7d57f432": {
        "hash = 7d57f432\nmatch_first_index = 0":"hash = 7d57f432\nmatch_first_index = 58749",
        "": dynamic_replacement,
    },
    # Jingyuan
    "1240ff30": {
        "hash = 1240ff30\nmatch_first_index = 17772":"hash = 1240ff30\nmatch_first_index = 53565",
        "": dynamic_replacement,
    },
    # Himeko
    "e79e4018": {
        "hash = e79e4018\nmatch_first_index = 0":"hash = e79e4018\nmatch_first_index = 27381",
        "": dynamic_replacement,
    },
    # Dr Ratio
    "d5f71e0e": {
        "hash = d5f71e0e\nmatch_first_index = 0":"hash = d5f71e0e\nmatch_first_index = 56361",
        "": dynamic_replacement,
    },
    # Yanqing
    "d03803e6": {
        "hash = d03803e6\nmatch_first_index = 0":"hash = d03803e6\nmatch_first_index = 55983",
        "": dynamic_replacement,
    },
    # Topaz
    "b52297bf": {
        "hash = b52297bf\nmatch_first_index = 21645":"hash = b52297bf\nmatch_first_index = 45078",
        "match_first_index = 0":"match_first_index = 21645",
        "": dynamic_replacement,
    },
    # Seele
    "6a522a54": {
        "hash = 6a522a54\nmatch_first_index = 0":"hash = 6a522a54\nmatch_first_index = 11550",
        "match_first_index = 19968":"match_first_index = 49764",
        "": dynamic_replacement,
    },
    # Lunae
    "7cb75a5e": {
        "hash = 7cb75a5e\nmatch_first_index = 0":"hash = 7cb75a5e\nmatch_first_index = 47133",
        "": dynamic_replacement,
    },
    # Jingliu
    "e8d31b6a": {
        "hash = e8d31b6a\nmatch_first_index = 0":"hash = e8d31b6a\nmatch_first_index = 51096",
        "": dynamic_replacement,
    },
    # Blade
    "0eb1e389": {
        "hash = 0eb1e389\nmatch_first_index = 0":"hash = 0eb1e389\nmatch_first_index = 44814",
        "": dynamic_replacement,
    },
    # Clara
    "4a58be98": {
        "hash = 4a58be98\nmatch_first_index = 0":"hash = 4a58be98\nmatch_first_index = 2016",
        "match_first_index = 19293":"match_first_index = 19290",
        "": dynamic_replacement,
    },
    # Lynx
    "71647b48": {
        "hash = 71647b48\nmatch_first_index = 0":"hash = 71647b48\nmatch_first_index = 51510",
        "": dynamic_replacement,
    },
    # Natasha
    "68dd15e8": {
        "hash = 68dd15e8\nmatch_first_index = 0":"hash = 68dd15e8\nmatch_first_index = 45612",
        "": dynamic_replacement,
    },
    # March7th
    "5212ce68": {
        "hash = 5212ce68\nmatch_first_index = 0":"hash = 5212ce68\nmatch_first_index = 53751",
        "match_first_index = 32502":"match_first_index = 41466",
        "": dynamic_replacement,
    },
    # Guinaifen
    "79900144": {
        "hash = 79900144\nmatch_first_index = 34146":"hash = 79900144\nmatch_first_index = 54723",
        "": dynamic_replacement,
    },
    # Luka
    "e0c9f7ec": {
        "hash = e0c9f7ec\nmatch_first_index = 28209":"hash = e0c9f7ec\nmatch_first_index = 49992",
        "": dynamic_replacement,
    },
    # Pela
    "98dbd548": {
        "hash = 98dbd548\nmatch_first_index = 0":"hash = 98dbd548\nmatch_first_index = 44043",
        "": dynamic_replacement,
    },
    # Hanya
    "b1c2c937": {
        "hash = b1c2c937\nmatch_first_index = 0":"hash = b1c2c937\nmatch_first_index = 51666",
        "match_first_index = 29886":"match_first_index = 52734",
        "": dynamic_replacement,
    },
    # Yukong
    "28bbd4ae": {
        "hash = 28bbd4ae\nmatch_first_index = 0":"hash = 28bbd4ae\nmatch_first_index = 55551",
        "": dynamic_replacement,
    },
    # Tingyun
    "da59600b": {
        "hash = da59600b\nmatch_first_index = 0":"hash = da59600b\nmatch_first_index = 54588",
        "match_first_index = 16053":"match_first_index = 10905",
        "": dynamic_replacement,
    },
    # Asta
    "8fb66ce1": {
        "hash = 8fb66ce1\nmatch_first_index = 40161":"hash = 8fb66ce1\nmatch_first_index = 4791",
        "match_first_index = 49917":"match_first_index = 11823",
        "": dynamic_replacement,
    },
    # Qingque
    "0a82ceb7": {
        "hash = 0a82ceb7\nmatch_first_index = 0":"hash = 0a82ceb7\nmatch_first_index = 23730",
        "match_first_index = 27765":"match_first_index = 27573",
        "": dynamic_replacement,
    },
    # Serval
    "f092876d": {
        "hash = f092876d\nmatch_first_index = 30048":"hash = f092876d\nmatch_first_index = 58380",
        "": dynamic_replacement,
    },
    # Herta
    "9553ff35": {
        "hash = 9553ff35\nmatch_first_index = 52458":"hash = 9553ff35\nmatch_first_index = 53166",
        "": dynamic_replacement,
    },
    # Sushang
    "4b22391b": {
        "hash = 4b22391b\nmatch_first_index = 30774":"hash = 4b22391b\nmatch_first_index = 44049",
        "": dynamic_replacement,
    },
    # Danheng
    "457b4223": {
        "hash = 457b4223\nmatch_first_index = 0":"hash = 457b4223\nmatch_first_index = 49005",
        "": dynamic_replacement,
    },
    # Xueyi
    "af2983dd": {
        "hash = af2983dd\nmatch_first_index = 0":"hash = af2983dd\nmatch_first_index = 31986",
        "match_first_index = 39129":"match_first_index = 54279",
        "": dynamic_replacement,
    },
    # Hook
    "0c614d18": {
        "hash = 0c614d18\nmatch_first_index = 0":"hash = 0c614d18\nmatch_first_index = 42189",
        "": dynamic_replacement,
    },
    # Arlan
    "31ebfc6e": {
        "hash = 31ebfc6e\nmatch_first_index = 0":"hash = 31ebfc6e\nmatch_first_index = 41721",
        "": dynamic_replacement,
    },
    # Cocolia
    "b0bf78bf": {
        "hash = b0bf78bf\nmatch_first_index = 38661":"hash = b0bf78bf\nmatch_first_index = 54927",
        "": dynamic_replacement,
    },
}


def process_folder(folder_path):
    '''Process all the files in the folder and subfolders,
    replacing the old values with the new ones.'''
    for root, dirs, files in os.walk(folder_path):
        for file in [x for x in files if x.lower().endswith('.ini') and x.lower() != 'desktop.ini']:
            file_path = os.path.join(root, file)
            print(f"--> Get in file '{file}' at '{file_path}'")
            try:
                with open(file_path, 'r', encoding="utf-8") as f:
                    s = f.read()
                    # old_stream = s
                if '[TextureOverride20fixA]' in s:
                    print(f"Skipping file '{file}' as it already contains '[TextureOverride20fixA]'")
                    continue
                modified = False
                for old, new in old_vs_new.items():
                    if old in s:
                        s = s.replace(old, new)
                        print(f" -  Hash '{old}' has been replase with '{new}'")
                        modified = True
                
                for key, values in replacement_mapping.items():
                    if key in s:
                        for search_string, replace_string in values.items():
                            if search_string not in s:
                                print(f" -  Not contain the specified string '{search_string}'. Skipping current string")
                                continue
                            else:
                                modified = True
                                if callable(replace_string):
                                    strr = replace_string(key)
                                    s += f'\n\n{strr}'
                                    print(f' -  {search_string[:4]}...{search_string[-4:]} --> {strr[:4]}...{strr[-4:]}')
                                else:
                                    s = s.replace(search_string, replace_string)
                                    print(f' -  {search_string[:4]}...{search_string[-4:]} --> {replace_string[:4]}...{replace_string[-4:]}')
                    else:
                        print(f" -  key '{key}' not in")
                if modified:
                    backup_file_path = os.path.join(root, f"backup_{os.path.splitext(file)[0]}.txt")
                    shutil.copy2(file_path, backup_file_path)
                    print(f" -  Backup created: '{backup_file_path}'")
                    with open(file_path, 'w', encoding="utf-8") as f:
                        f.write(s)
                        print(f'<-- File has been modified!')
                else:
                    print(f'<-- File had no matches. Skipping')
            except Exception as e:
                print(f'Error processing file: {file_path}')
                print(e)
                continue

if __name__ == '__main__':
    process_folder(os.getcwd())
    input('Done!')
